Index: trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportAction.java
===================================================================
--- trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportAction.java	(revision 1607)
+++ trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportAction.java	(revision 1608)
@@ -6,6 +6,7 @@
 package org.gvsig.app.project.documents.layout.report;
 
 import org.gvsig.fmap.dal.swing.report.ReportAction;
+import org.gvsig.tools.resourcesstorage.ResourcesStorage;
 
 /**
  *
@@ -13,45 +14,10 @@
  */
 public interface LayoutReportAction extends ReportAction {
 
-    String LAYOUT_REPORT_BUFFER_SIZE = "bufferSize";
-    String LAYOUT_REPORT_CENTER_TO_CURRENT_ROW = "centerToCurrentRow";
-    String LAYOUT_REPORT_DEFAULT_TEMPLATE_NAME = "layout";
-    String LAYOUT_REPORT_LABEL = "label";
-    String LAYOUT_REPORT_NAME = "name";
-    String LAYOUT_REPORT_TEMPLATE_NAME = "templateName";
-    String LAYOUT_REPORT_HIGHLIGHT_RECORD = "highlightRecord";
-    String LAYOUT_REPORT_HIGHLIGHT_SYMBOL = "highlightSymbol";
-//    String LAYOUT_REPORT_LINE_COLOR = "lineColor";
-//    String LAYOUT_REPORT_FILL_COLOR = "fillColor";
-    String LAYOUT_REPORT_TYPE = "type";
-    String LAYOUT_REPORT_VIEW_TAG = "viewTag";
-    String LAYOUT_REPORT_USE_INTERNAL_PDF_VIEWER = "useInternalPdfViewer";
-    String LAYOUT_REPORT_ZOOM_TO_CURRENT_ROW = "zoomToCurrentRow";
-
     String evaluateDynamicText(String s);
-
-    double getBufferSize();
-
-    boolean isCenterToCurrentRow();
-
-    boolean isZoomToCurrentRow();
     
-    boolean isUseInternalPdfViewer();
+    public LayoutReportActionParameters getParameters();
 
-    void setBufferSize(double bufferSize);
-
-    void setCenterToCurrentRow(boolean centerToCurrentRow);
-
-    public String getViewTag();
-
-    public void setViewTag(String viewTag);
+    public ResourcesStorage.Resource getTemplateAsResource();
     
-    void setUseInternalPdfViewer(boolean useInternalPdfViewer);
-
-    void setZoomToCurrentRow(boolean zoomToCurrentRow);
-    
-    public boolean isHighlightRecord();
-   
-    public void setHighlightRecord(boolean b);
-    
 }
Index: trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionImpl.java
===================================================================
--- trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionImpl.java	(revision 1607)
+++ trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionImpl.java	(revision 1608)
@@ -1,31 +1,23 @@
 package org.gvsig.app.project.documents.layout.report;
 
-import java.awt.Color;
 import java.awt.Dimension;
 import java.awt.event.ActionEvent;
 import java.awt.geom.Point2D;
-import java.io.ByteArrayInputStream;
 import java.io.File;
 import java.io.InputStream;
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Objects;
-import java.util.logging.Level;
-import java.util.logging.Logger;
-import javax.json.JsonNumber;
 import javax.json.JsonObject;
 import javax.swing.JComponent;
 import javax.swing.JOptionPane;
 import javax.swing.SwingUtilities;
-import org.apache.commons.codec.DecoderException;
-import org.apache.commons.codec.binary.Hex;
 import org.apache.commons.io.IOUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.ICoordTrans;
 import org.gvsig.andami.ui.mdiManager.IWindow;
 import org.gvsig.app.ApplicationLocator;
 import org.gvsig.app.ApplicationManager;
-import org.gvsig.app.gui.styling.SymbolSelector;
 import org.gvsig.app.project.documents.Document;
 import org.gvsig.app.project.documents.layout.LayoutContext;
 import org.gvsig.app.project.documents.layout.fframes.FFrameView;
@@ -34,7 +26,6 @@
 import static org.gvsig.app.project.documents.layout.report.LayoutReportActionFactory.LAYOUT_REPORT_ACTION_NAME;
 import org.gvsig.app.project.documents.view.ViewDocument;
 import org.gvsig.app.project.documents.view.gui.IView;
-import org.gvsig.app.project.documents.view.legend.gui.ISymbolSelector;
 import org.gvsig.desktopopen.DesktopOpen;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
@@ -44,7 +35,6 @@
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.expressionevaluator.FeatureSymbolTable;
 import org.gvsig.fmap.dal.feature.Feature;
-import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
 import org.gvsig.fmap.dal.feature.FeatureSelection;
 import org.gvsig.fmap.dal.feature.FeatureSet;
@@ -58,20 +48,16 @@
 import org.gvsig.fmap.geom.exception.CreateEnvelopeException;
 import org.gvsig.fmap.geom.primitive.Envelope;
 import org.gvsig.fmap.mapcontext.MapContext;
-import org.gvsig.fmap.mapcontext.MapContextLocator;
 import org.gvsig.fmap.mapcontext.ViewPort;
 import org.gvsig.fmap.mapcontext.layers.FLayer;
 import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
 import org.gvsig.fmap.mapcontext.layers.vectorial.GraphicLayer;
-import org.gvsig.fmap.mapcontext.rendering.symbols.ISymbol;
-import org.gvsig.json.Json;
 import org.gvsig.pdf.lib.api.PDFDocument;
 import org.gvsig.pdf.lib.api.PDFLocator;
 import org.gvsig.pdf.lib.api.PDFManager;
 import org.gvsig.pdf.swing.api.PDFSwingLocator;
 import org.gvsig.pdf.swing.api.PDFSwingManager;
 import org.gvsig.pdf.swing.api.PDFViewer;
-import org.gvsig.symbology.fmap.mapcontext.rendering.symbol.fill.IFillSymbol;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dispose.DisposeUtils;
 import org.gvsig.tools.exception.BaseException;
@@ -123,52 +109,29 @@
     }
     
     
-    private final JsonObject json;
     private final FeatureStore store;
     private FeatureQuery query;
     private FeatureSet selection;
     private Feature current_row;
     private MutableSymbolTable symbolTable;
     private FeatureSymbolTable fSymbolTable;
-    private boolean centerToCurrentRow;
-    private boolean zoomToCurrentRow;
-    private double bufferSize;
-    private boolean useInternalPdfViewer;
     private Iterable<Feature> set;
     private int featuresCount;
-    private String viewTag;
-    private boolean highlightRecord;
-    private ISymbol highlightSymbol;
-//    private Color fillColor;
-//    private Color lineColor;
+    private LayoutReportActionParameters parameters;
     
     @SuppressWarnings("OverridableMethodCallInConstructor")
     private LayoutReportActionImpl(ReportActionFactory factory, FeatureStore store, JsonObject json) {
         super(factory, null);
-        this.json = json;
         this.store = store;
         this.selection = null;
         this.query = null;
         this.current_row = null;
         
-        this.setReportName(this.json.getString(LAYOUT_REPORT_NAME, store.getName()));
-        this.setReportLabel(this.json.getString(LAYOUT_REPORT_LABEL, this.getReportName()));
-        this.highlightRecord = this.json.getBoolean(LAYOUT_REPORT_HIGHLIGHT_RECORD, true);
-        this.highlightSymbol = createSymbol(this.json.getString(LAYOUT_REPORT_HIGHLIGHT_SYMBOL, null));
-//        this.fillColor = new Color(this.json.getInt(LAYOUT_REPORT_FILL_COLOR, Color.WHITE.getRGB()&(0x2F<<24)));
-//        this.lineColor = new Color(this.json.getInt(LAYOUT_REPORT_LINE_COLOR, Color.WHITE.getRGB()));
-        this.setCenterToCurrentRow(this.json.getBoolean(LAYOUT_REPORT_CENTER_TO_CURRENT_ROW, true));
-        this.setZoomToCurrentRow(this.json.getBoolean(LAYOUT_REPORT_ZOOM_TO_CURRENT_ROW, true));
-        this.setBufferSize(0.0);
-        if(this.json.containsKey(LAYOUT_REPORT_BUFFER_SIZE)){
-            JsonNumber theSize = this.json.getJsonNumber(LAYOUT_REPORT_BUFFER_SIZE);
-            if(theSize != null){
-                this.setBufferSize(theSize.doubleValue());
-            }
-        } 
-        this.setViewTag(this.json.getString(LAYOUT_REPORT_VIEW_TAG, null));
-        this.setUseInternalPdfViewer(this.json.getBoolean(LAYOUT_REPORT_USE_INTERNAL_PDF_VIEWER, true));
+        this.parameters = LayoutReportActionParameters.create();
+        this.parameters.fromJson(json);
         
+        this.setReportName(this.parameters.getIdentifier());
+        this.setReportLabel(this.parameters.getLabel());
     }
     
     @SuppressWarnings("OverridableMethodCallInConstructor")
@@ -177,11 +140,7 @@
         this(
                 factory, 
                 store, 
-                Json.createObjectBuilder()
-                .add(LAYOUT_REPORT_NAME, store.getName())
-                .add(LAYOUT_REPORT_TYPE, LAYOUT_REPORT_ACTION_NAME)
-                .add(LAYOUT_REPORT_LABEL, store.getName())
-                .build()
+                LayoutReportActionParameters.create(store.getName()).toJson()
         );
         try {
             this.selection = store.createFeatureSelection();
@@ -279,7 +238,7 @@
                         PDFManager pdfManager = PDFLocator.getPDFManager();
                         pdfManager.merge(singlePdfFiles, pdfFile, title, creator, subject, theStatus);
 
-                        if (this.isUseInternalPdfViewer()) {
+                        if (this.parameters.isUseInternalPdfViewer()) {
                             this.showEmbedded(pdfFile);
                         } else {
                             this.showExternal(pdfFile);
@@ -307,7 +266,7 @@
     
     private File printReport(Feature feature, int page) throws Exception {
         this.current_row = feature;
-        final LayoutPanel layout = this.loadTemplate();
+        final LayoutPanel layout = this.getTemplateAsLayout();
         final LayoutContext context = layout.getLayoutContext();
         final Document document = layout.getDocument();
 
@@ -338,8 +297,8 @@
                     }
                     String frameTag = frame.getTag();
                     String countTag = "#" + count;
-                    if (StringUtils.equalsIgnoreCase(this.getViewTag(), frameTag)
-                            || StringUtils.equalsIgnoreCase(this.getViewTag(), countTag)) {
+                    if (StringUtils.equalsIgnoreCase(this.parameters.getViewTag(), frameTag)
+                            || StringUtils.equalsIgnoreCase(this.parameters.getViewTag(), countTag)) {
                         mapContext = ((FFrameView) frame).getMapContext();
                         break;
                     }
@@ -351,7 +310,7 @@
 
             FeatureStore storeInLayout = this.store;
             if (mapContext != null) {
-                mapContext.setPrintGraphicsLayer(this.isHighlightRecord());
+                mapContext.setPrintGraphicsLayer(this.parameters.isHighlightRecord());
                 ICoordTrans ct = null;
                 for (FLayer layer : mapContext.getLayers().getLayers(null)) {
                     if (layer instanceof FLyrVect) {
@@ -374,27 +333,31 @@
                         ct = geom.getProjection().getCT(mapContext.getProjection());
                         geom.reProject(ct);
                     }
-                    if (isZoomToCurrentRow()) {
+                    if (this.parameters.isZoomToCurrentRow()) {
 
                         Envelope envelope = geom
-                                .getEnvelope().getGeometry().buffer(getBufferSize()).getEnvelope();
+                                .getEnvelope().getGeometry().buffer(this.parameters.getBufferSize()).getEnvelope();
                         mapContext.getViewPort().setEnvelope(envelope);
 
-                    } else if (isCenterToCurrentRow()) {
+                    } else if (this.parameters.isCenterToCurrentRow()) {
 
                         Envelope envelope = geom
-                                .getEnvelope().getGeometry().buffer(getBufferSize()).getEnvelope();
+                                .getEnvelope().getGeometry().buffer(this.parameters.getBufferSize()).getEnvelope();
                         center(mapContext, envelope);
 
                     } else {
                         //DO NOTHING ??
                     }
-                    if(this.isHighlightRecord()){
+                    if(this.parameters.isHighlightRecord()){
                         GraphicLayer graphicsLayer = mapContext.getGraphicsLayer();
                         graphicsLayer.clear();
-                        int idSymbol = graphicsLayer.addSymbol(this.highlightSymbol);
-                        //TODO: Decidir si aplicamos el simbolo a la geometría o al resto
-//                        geom = mapContext.getViewPort().getAdjustedEnvelope().getGeometry().difference(geom);
+                        int idSymbol = graphicsLayer.addSymbol(this.parameters.getHighlightSymbol(this.store));
+                        if(this.parameters.isApplySymbolToRecord()){
+                            //Do nothing, is the default behavior
+                        }
+                        if(this.parameters.isApplySymbolToEverythingExceptRecord()){
+                            geom = mapContext.getViewPort().getAdjustedEnvelope().getGeometry().difference(geom);
+                        }
                         graphicsLayer.addGraphic("", geom, idSymbol);
                     }
                 }
@@ -484,13 +447,11 @@
         desktop.open(pdfFile);
     }
     
-    private LayoutPanel loadTemplate() throws Exception {
-        ResourcesStorage resources = store.getResourcesStorage();
-        if (resources == null) {
+    private LayoutPanel getTemplateAsLayout() throws Exception {
+        ResourcesStorage.Resource resource = getTemplateAsResource();
+        if(resource == null){
             return null;
         }
-        String templateName = this.json.getString(LAYOUT_REPORT_TEMPLATE_NAME, LAYOUT_REPORT_DEFAULT_TEMPLATE_NAME); // "1.layout"...
-        ResourcesStorage.Resource resource = resources.getResource(templateName);
         InputStream is = null;
         try {
             is = resource.asInputStream();
@@ -505,6 +466,17 @@
         }
     }
     
+    @Override
+    public ResourcesStorage.Resource getTemplateAsResource() {
+        ResourcesStorage resources = store.getResourcesStorage();
+        if (resources == null) {
+            return null;
+        }
+        String templateName = this.parameters.getTemplateName(); //.getString(LAYOUT_REPORT_TEMPLATE_NAME, LAYOUT_REPORT_DEFAULT_TEMPLATE_NAME); // "1.layout"...
+        ResourcesStorage.Resource resource = resources.getResource(templateName);
+        return resource;
+    }
+    
     public MutableSymbolTable getSymbolTable() {
         if( this.symbolTable == null ) {
             this.symbolTable = ExpressionUtils.createSymbolTable();
@@ -530,87 +502,9 @@
         );
         return x;
     }
-
-    @Override
-    public boolean isCenterToCurrentRow() {
-        return this.centerToCurrentRow;
-    }
-
-    @Override
-    public void setCenterToCurrentRow(boolean centerToCurrentRow) {
-        this.centerToCurrentRow = centerToCurrentRow;
-    }
     
-    @Override
-    public boolean isZoomToCurrentRow() {
-        return this.zoomToCurrentRow;
+    public LayoutReportActionParameters getParameters() {
+        return this.parameters;
     }
 
-    @Override
-    public void setZoomToCurrentRow(boolean zoomToCurrentRow) {
-        this.zoomToCurrentRow = zoomToCurrentRow;
-    }
-    
-    @Override
-    public double getBufferSize() {
-        return bufferSize;
-    }
-
-    @Override
-    public void setBufferSize(double bufferSize) {
-        this.bufferSize = bufferSize;
-    }
-    
-    @Override
-    public String getViewTag() {
-        return viewTag;
-    }
-
-    @Override
-    public void setViewTag(String viewTag) {
-        this.viewTag = viewTag;
-    }
-    
-    public  boolean isUseInternalPdfViewer() {
-        return useInternalPdfViewer;
-    }
-
-    @Override
-    public void setUseInternalPdfViewer(boolean useInternalPdfViewer) {
-        this.useInternalPdfViewer = useInternalPdfViewer;
-    }
-
-    @Override
-    public boolean isHighlightRecord() {
-        return this.highlightRecord;
-    }
-   
-    @Override
-    public void setHighlightRecord(boolean b) {
-        this.highlightRecord = b;
-    }
-
-    private ISymbol createSymbol(String s) {
-        FeatureAttributeDescriptor geomAttr = this.store.getDefaultFeatureTypeQuietly().getDefaultGeometryAttribute();
-        if (geomAttr == null) {
-            return null;
-        }
-        int geomType = geomAttr.getGeomType().getType();
-
-        try {
-            if (StringUtils.isBlank(s)) {
-                return MapContextLocator.getMapContextManager().createSymbol(geomType);
-            }
-
-            byte[] bytes = Hex.decodeHex(s.toCharArray());
-            PersistenceManager persistenceManager = ToolsLocator.getPersistenceManager();
-            InputStream in = new ByteArrayInputStream(bytes);
-            ISymbol symbol = (ISymbol) persistenceManager.getObject(in);
-            return symbol;
-        } catch (DecoderException ex) {
-            return MapContextLocator.getMapContextManager().createSymbol(geomType);
-        }
-
-    }
-
 }
Index: trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionParameters.java
===================================================================
--- trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionParameters.java	(revision 0)
+++ trunk/org.gvsig.app.document.layout2.app/org.gvsig.app.document.layout2.app.mainplugin/src/main/java/org/gvsig/app/project/documents/layout/report/LayoutReportActionParameters.java	(revision 1608)
@@ -0,0 +1,82 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.gvsig.app.project.documents.layout.report;
+
+import java.io.IOException;
+import org.gvsig.app.project.documents.layout.LayoutDocument;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.mapcontext.rendering.symbols.ISymbol;
+import org.gvsig.json.SupportJson;
+
+/**
+ *
+ * @author fdiaz
+ */
+public interface LayoutReportActionParameters extends SupportJson {
+    
+    public static LayoutReportActionParameters create(){
+        return new LayoutReportActionParametersImpl();
+    }
+    
+    public static LayoutReportActionParameters create(String name){
+        return new LayoutReportActionParametersImpl(name);
+    }
+
+    public String getIdentifier();
+
+    public void setIdentifier(String identifier);
+
+    public String getLabel();
+
+    public void setLabel(String label);
+
+    public boolean isCenterToCurrentRow();
+
+    public void setCenterToCurrentRow(boolean centerToCurrentRow);
+
+    public boolean isZoomToCurrentRow();
+
+    public void setZoomToCurrentRow(boolean zoomToCurrentRow);
+
+    public double getBufferSize();
+
+    public void setBufferSize(double bufferSize);
+
+    public boolean isHighlightRecord();
+
+    public void setHighlightRecord(boolean b);
+
+    public boolean isApplySymbolToRecord();
+
+    public void setApplySymbolToRecord(boolean b);
+
+    public boolean isApplySymbolToEverythingExceptRecord();
+
+    public void setApplySymbolToEverythingExceptRecord(boolean b);
+
+    public boolean isUseInternalPdfViewer();
+
+    public void setUseInternalPdfViewer(boolean useInternalPdfViewer);
+
+    public String getViewTag();
+
+    public void setViewTag(String tag);
+    
+    public ISymbol getHighlightSymbol(FeatureStore featureStore);
+    
+    public void setHighlightSymbol(ISymbol symbol);
+    
+    public String getHighlightSymbolSerialized();
+
+    public void setHighlightSymbolSerialized(String symbol);
+
+    public void setTemplateName(String templateName);
+
+    public String getTemplateName();
+
+    public void save(FeatureStore store, LayoutDocument layout) throws IOException;
+    
+}
